<RccWorker language='c++' spec='drc' version='2'>

  <specProperty Name="MAX_CONFIGURATIONS_p" value='1'/>

  <!-- 2 ports per Daughterboard (RX/TX), 2 Daughterboards -->
  <specProperty name='MAX_CHANNELS_p' value="8"/>
  <specProperty name='MAX_RX_CHANNELS_p' value="4"/>
  <specProperty name='MAX_TX_CHANNELS_p' value="4"/>


  <!-- FSM Declarations -->
  <specProperty name='prepare' writesync='1'/>
  <specProperty name='start' writesync='1'/>
  <specProperty name='stop' writesync='1'/>
  <specProperty name='release' writesync='1'/>
  <specProperty name='status' readsync='1'/>


  <!-- rf_port_num Initialization for Channel Deployment -->
  <!-- Force worker to initialize rf_port_num properties to '-1' == 255 in UCHAR data type -->
  <specProperty name='configurations' default='
    {
      channels {
        {rf_port_num 0xFF},
        {rf_port_num 0xFF},
        {rf_port_num 0xFF},
        {rf_port_num 0xFF},
        {rf_port_num 0xFF},
        {rf_port_num 0xFF},
        {rf_port_num 0xFF},
        {rf_port_num 0xFF} }}'/>


  <!-- DRC Application Configuration Parameters --> 
  <property name='dba_en' type='bool' parameter='true' default='false' description='Build-time parameter for Daugtherboard A: ``true`` = ``DBA_jesd_axi_mapper`` and ``DBA_gpio`` device workers are enabled within the slave assembly, ``false`` = All device workers are disabled within the slave assembly.'/>
  <property name='dba_tx0_en' type='bool' parameter='true' default='false' description='Build-time parameter for Daugtherboard A TX0 channel:  ``true`` = ``DBA_qDAC0`` and ``DBA_qdac_sub`` device workers are enabled within the slave assembly, ``false`` = ``DBA_qDAC0`` and ``DBA_qdac_sub`` device workers are disabled within the slave assembly.'/>
  <property name='dba_tx1_en' type='bool' parameter='true' default='false' description='Build-time parameter for Daugtherboard A TX1 channel:  ``true`` = ``DBA_qDAC1`` and ``DBA_qdac_sub`` device workers are enabled within the slave assembly, ``false`` = ``DBA_qDAC0`` and ``DBA_qdac_sub`` device workers are disabled within the slave assembly.'/>
  <property name='dba_rx0_en' type='bool' parameter='true' default='false' description='Build-time parameter for Daugtherboard A RX0 channel:  ``true`` = ``DBA_qADC0`` and ``DBA_qadc_sub`` device workers are enabled within the slave assembly, ``false`` = ``DBA_qADC0`` and ``DBA_qadc_sub`` device workers are disabled within the slave assembly.'/>
  <property name='dba_rx1_en' type='bool' parameter='true' default='false' description='Build-time parameter for Daugtherboard A RX1 channel:  ``true`` = ``DBA_qADC1`` and ``DBA_qadc_sub`` device workers are enabled within the slave assembly, ``false`` = ``DBA_qADC1`` and ``DBA_qadc_sub`` device worker are disabled within the slave assembly.'/>
  
  <property name='dbb_en' type='bool' parameter='true' default='false' description='Build-time parameter for Daugtherboard B: ``true`` = ``DBB_jesd_axi_mapper`` and ``DBB_gpio`` device workers are enabled within the slave assembly, ``false`` = All device workers are disabled within the slave assembly.'/>
  <property name='dbb_tx0_en' type='bool' parameter='true' default='false' description='Build-time parameter for Daugtherboard B TX0 channel:  ``true`` = ``DBB_qDAC0`` and ``DBB_qdac_sub`` device workers are enabled within the slave assembly, ``false`` = ``DBB_qDAC0`` and ``DBB_qdac_sub`` device workers are disabled within the slave assembly.'/>
  <property name='dbb_tx1_en' type='bool' parameter='true' default='false' description='uild-time parameter for Daugtherboard B TX1 channel:  ``true`` = ``DBB_qDAC1`` and ``DBB_qdac_sub`` device workers are enabled within the slave assembly, ``false`` = ``DBB_qDAC0`` and ``DBB_qdac_sub`` device workers are disabled within the slave assembly.'/>
  <property name='dbb_rx0_en' type='bool' parameter='true' default='false' description='Build-time parameter for Daugtherboard B RX0 channel:  ```true`` = ``DBB_qADC0`` and ``DBB_qadc_sub`` device workers are enabled within the slave assembly, ``false`` = ``DBB_qADC0`` and ``DBB_qadc_sub`` device workers are disabled within the slave assembly.'/>
  <property name='dbb_rx1_en' type='bool' parameter='true' default='false' description='Build-time parameter for Daugtherboard B RX1 channel:  ``true`` = ``DBB_qADC1`` and ``DBB_qadc_sub`` device workers are enabled within the slave assembly, ``false`` = ``DBB_qADC1`` and ``DBB_qadc_sub`` device worker are disabled within the slave assembly.'/>
  
  <property name='dba_cic_int_en' type='bool' parameter='true' default='true' description='Build-time parameter for CIC Interpolation Workers for Daughterboard A:  ``true`` = ``DBA_cic_int0`` and ``DBA_cic_int1`` device workers are enabled within the slave assembly, ``false`` = CIC Interpolation device workers are disabled within the slave assembly.'/>
  <property name='dba_cic_dec_en' type='bool' parameter='true' default='true' description='Build-time parameter for CIC Decimation Workers for Daugtherboard A:  ``true`` = ``DBA_cic_dec0`` and ``DBA_cic_dec01`` device workers are enabled within the slave assembly, ``false`` = CIC Decimation device workers are disabled within the slave assembly.'/>
  <property name='dbb_cic_int_en' type='bool' parameter='true' default='true' description='Build-time parameter for CIC Interpolation Workers for Daugtherboard B:  ``true`` = ``DBB_cic_int0`` and ``DBB_cic_int1`` device workers are enabled within the slave assembly, ``false`` = Interpolation device workers are disabled within the slave assembly.'/>
  <property name='dbb_cic_dec_en' type='bool' parameter='true' default='true' description='Build-time parameter for CIC Decimation Workers for Daugtherboard B:  ``true`` = ``DBA_cic_dec0`` and ``DBA_cic_dec1`` device workers are enabled within the slave assembly, ``false`` = CIC Decimation device workers are disabled within the slave assembly.'/>
  

  <!-- DRC Application Configuration Properties -->
  <property name='dba_int0_up_sample_factor' type='ushort' writable='true' default='1' description='Interpolation Factor for Daughterboard A TX0 CIC (``DBA_cic_int0``) device worker.'/>
  <property name='dba_int0_scale_output' type='uchar' writable='true' default='5' description='Output scale factor for Daughterboard A TX0 CIC (``DBA_cic_int0``) device worker. The output is divided by :math:`2^{\texttt{dba_int0_scale_output}}`.'/>
  <property name='dba_int0_flush_length' type='ushort' writable='true' default='0' description='The number of zero samples inserted into the Daughterboard A TX0 CIC (``DBA_cic_int0``) device worker on receipt of a flush opcode.'/>
  <property name='dba_int1_up_sample_factor' type='ushort' writable='true' default='1' description='Interpolation Factor for Daughterboard A TX1 CIC (``DBA_cic_int1``) device worker.'/>
  <property name='dba_int1_scale_output' type='uchar' writable='true' default='5' description='Output scale factor for Daughterboard A TX1 CIC (``DBA_cic_int1``) device worker. The output is divided by :math:`2^{\texttt{dba_int1_scale_output}}`.'/>
  <property name='dba_int1_flush_length' type='ushort' writable='true' default='0' description='The number of zero samples inserted into the Daughterboard A TX1 CIC (``DBA_cic_int1``) device worker on receipt of a flush opcode.'/>

  <property name='dba_dec0_down_sample_factor' type='ushort' writable='true' default='1' description='Decimation Factor for Daughterboard A RX0 CIC (``DBA_cic_dec0``) device worker.'/>
  <property name='dba_dec0_scale_output' type='uchar' writable='true' default='5' description='Output scale factor for Daughterboard A RX0 CIC (``DBA_cic_dec0``) device worker. The output is divided by :math:`2^{\texttt{dba_dec0_scale_output}}`.'/>
  <property name='dba_dec0_flush_length' type='ushort' writable='true' default='0' description='The number of zero samples inserted into the Daughterboard A RX0 CIC (``DBA_cic_dec0``) device worker on receipt of a flush opcode.'/>
  <property name='dba_dec1_down_sample_factor' type='ushort' writable='true' default='1' description='Decimation Factor for Daughterboard A RX1 CIC (``DBA_cic_dec1``) device worker.'/>
  <property name='dba_dec1_scale_output' type='uchar' writable='true' default='5' description='Output scale factor for Daughterboard A RX1 CIC (``DBA_cic_dec1``) device worker. The output is divided by :math:`2^{\texttt{dba_dec1_scale_output}}`.'/>
  <property name='dba_dec1_flush_length' type='ushort' writable='true' default='0' description='The number of zero samples inserted into the Daughterboard A RX1 CIC (``DBB_cic_dec1``) device worker on receipt of a flush opcode.'/>

  <property name='dbb_int0_up_sample_factor' type='ushort' writable='true' default='1' description='Interpolation Factor for Daughterboard B TX0 CIC (``DBB_cic_int0``) device worker.'/>
  <property name='dbb_int0_scale_output' type='uchar' writable='true' default='5' description='Output scale factor for Daughterboard B TX0 CIC (``DBB_cic_int0``) device worker. The output is divided by :math:`2^{\texttt{dbb_int0_scale_output}}`.'/>
  <property name='dbb_int0_flush_length' type='ushort' writable='true' default='0' description='The number of zero samples inserted into the Daughterboard B TX0 CIC (``DBB_cic_int0``) device worker on receipt of a flush opcode.'/>
  <property name='dbb_int1_up_sample_factor' type='ushort' writable='true' default='1' description='Interpolation Factor for Daughterboard B TX1 CIC (``DBB_cic_int1``) device worker.'/>
  <property name='dbb_int1_scale_output' type='uchar' writable='true' default='5' description='Output scale factor for Daughterboard B TX1 CIC (``DBB_cic_int1``) device worker. The output is divided by :math:`2^{\texttt{dbb_int1_scale_output}}`.'/>
  <property name='dbb_int1_flush_length' type='ushort' writable='true' default='0' description='The number of zero samples inserted into the Daughterboard B TX1 CIC (``DBB_cic_int1``) device worker on receipt of a flush opcode.'/>

  <property name='dbb_dec0_down_sample_factor' type='ushort' writable='true' default='1' description='Decimation Factor for Daughterboard B RX0 CIC (``DBB_cic_dec0``) device worker.'/>
  <property name='dbb_dec0_scale_output' type='uchar' writable='true' default='5' description='Output scale factor for Daughterboard B RX0 CIC (``DBB_cic_dec0``) device worker. The output is divided by :math:`2^{\texttt{dbb_dec0_scale_output}}`.'/>
  <property name='dbb_dec0_flush_length' type='ushort' writable='true' default='0' description='The number of zero samples inserted into the Daughterboard B RX0 CIC (``DBB_cic_dec0``) device worker on receipt of a flush opcode.'/>
  <property name='dbb_dec1_down_sample_factor' type='ushort' writable='true' default='1' description='Decimation Factor for Daughterboard B RX1 CIC (``DBB_cic_dec1``) device worker.'/>
  <property name='dbb_dec1_scale_output' type='uchar' writable='true' default='5' description='Output scale factor for Daughterboard B RX1 CIC (``DBB_cic_dec1``) device worker. The output is divided by :math:`2^{\texttt{dbb_dec1_scale_output}}`.'/>
  <property name='dbb_dec1_flush_length' type='ushort' writable='true' default='0' description='The number of zero samples inserted into the Daughterboard B RX1 CIC (``DBB_cic_dec1``) device worker on receipt of a flush opcode.'/>


  <!--JESD Lane Configuration Properties --> 
  <property name='dba_dac_channels_are_swapped' type='bool' writable='true' default='false' description='Channel mapping for Daughterboard A qDAC device sub-worker (``DBA_qdac_sub``): ``true`` = qDAC1 to DAC0/1, qDAC0 to DAC2/3, ``false`` = qDAC0 to DAC0/1 and qDAC1 to DAC2/3.'/>
  <property name='dba_dac_lanes_are_swapped' type='bool' writable='true' default='false' description='JESD Lane mapping for the Daughterboard A qDAC device sub-worker (``DBA_qdac_sub``): ``true`` = DAC0 is swapped with DAC1, DAC2 is swapped with DAC3, ``false`` = DAC Lanes are not swapped.'/>
  <property name='dba_dac_mask_ch0i' type='ushort' writable='true' default='0xffff' description='Bit masking for channel0 of Daughterboard A qDAC device sub-worker (``DBA_qdac_sub``).'/>
  <property name='dba_dac_mask_ch0q' type='ushort' writable='true' default='0xffff' description='Bit masking for channel0 of Daughterboard A qDAC device sub-worker (``DBA_qdac_sub``).'/>
  <property name='dba_dac_mask_ch1i' type='ushort' writable='true' default='0xffff' description='Bit masking for channel1 of Daughterboard A qDAC device sub-worker (``DBA_qdac_sub``).'/>
  <property name='dba_dac_mask_ch1q' type='ushort' writable='true' default='0xffff' description='Bit masking for channel1 of Daughterboard A qDAC device sub-worker (``DBA_qdac_sub``).'/>
  
  <property name='dba_adc_channels_are_swapped' type='bool' writable='true' default='false' description='dba_adc_channels_are_swapped: Channel mapping for Daughterboard A qADC device sub-worker (``DBA_qadc_sub``): ``true`` = ADC0/1 to qADC1, ADC2/3 to qADC0, ``false`` = ADC0/1 to qADC0 and ADC2/3 to qADC1.'/>
  <property name='dba_adc_lanes_are_swapped' type='bool' writable='true' default='false' description='JESD Lane mapping for the Daughterboard A qADC device sub-worker (``DBA_qadc_sub``): ``true`` = ADC0 is swapped with ADC1, ADC2 is swapped with ADC3, ``false`` = ADC Lanes are not swapped.'/>
  <property name='dba_adc_mask_ln0' type='ushort' writable='true' default='0xffff' description='Bit masking for ADC0 of Daughterboard B qADC device sub-worker (``DBA_qadc_sub``).'/>
  <property name='dba_adc_mask_ln1' type='ushort' writable='true' default='0xffff' description='Bit masking for ADC1 of Daughterboard B qADC device sub-worker (``DBA_qadc_sub``).'/>
  <property name='dba_adc_mask_ln2' type='ushort' writable='true' default='0xffff' description='Bit masking for ADC2 of Daughterboard B qADC device sub-worker (``DBA_qadc_sub``).'/>
  <property name='dba_adc_mask_ln3' type='ushort' writable='true' default='0xffff' description='Bit masking for ADC3 of Daughterboard B qADC device sub-worker (``DBA_qadc_sub``).'/>
  
  <property name='dbb_dac_channels_are_swapped' type='bool' writable='true' default='false' description='Channel mapping for Daughterboard B qDAC device sub-worker (``DBB_qdac_sub``): ``true`` = qDAC1 to DAC0/1, qDAC0 to DAC2/3, ``false`` = qDAC0 to DAC0/1 and qDAC1 to DAC2/3.'/>
  <property name='dbb_dac_lanes_are_swapped' type='bool' writable='true' default='false' description='JESD Lane mapping for the Daughterboard B qDAC device sub-worker (``DBB_qdac_sub``): ``true`` = DAC0 is swapped with DAC1, DAC2 is swapped with DAC, ``false`` = DAC Lanes are not swapped.'/>
  <property name='dbb_dac_mask_ch0i' type='ushort' writable='true' default='0xffff' description='Bit masking for channel0 of Daughterboard A qDAC device sub-worker (``DBB_qdac_sub``).'/>
  <property name='dbb_dac_mask_ch0q' type='ushort' writable='true' default='0xffff' description='Bit masking for channel1 of Daughterboard A qDAC device sub-worker (``DBB_qdac_sub``).'/>
  <property name='dbb_dac_mask_ch1i' type='ushort' writable='true' default='0xffff' description='Bit masking for channel2 of Daughterboard A qDAC device sub-worker (``DBB_qdac_sub``).'/>
  <property name='dbb_dac_mask_ch1q' type='ushort' writable='true' default='0xffff' description='Bit masking for channel3 of Daughterboard A qDAC device sub-worker (``DBB_qdac_sub``).'/>
  
  <property name='dbb_adc_channels_are_swapped' type='bool' writable='true' default='false' description='Channel mapping for Daughterboard B qADC device sub-worker (``DBB_qadc_sub``): ``true`` = ADC0/1 to qADC1, ADC2/3 to qADC0, ``false`` = ADC0/1 to qADC0 and ADC2/3 to qADC1.'/>
  <property name='dbb_adc_lanes_are_swapped' type='bool' writable='true' default='false' description='JESD Lane mapping for the Daughterboard B qADC device sub-worker (``DBB_qadc_sub``): ``true`` = ADC0 is swapped with ADC1, ADC2 is swapped with ADC3, ``false`` = ADC Lanes are not swapped.'/>
  <property name='dbb_adc_mask_ln0' type='ushort' writable='true' default='0xffff' description='Bit masking for ADC0 of Daughterboard B qADC device sub-worker (``DBB_qadc_sub``).'/>
  <property name='dbb_adc_mask_ln1' type='ushort' writable='true' default='0xffff' description='Bit masking for ADC1 of Daughterboard B qADC device sub-worker (``DBB_qadc_sub``).'/>
  <property name='dbb_adc_mask_ln2' type='ushort' writable='true' default='0xffff' description='Bit masking for ADC2 of Daughterboard B qADC device sub-worker (``DBB_qadc_sub``).'/>
  <property name='dbb_adc_mask_ln3' type='ushort' writable='true' default='0xffff' description='Bit masking for ADC3 of Daughterboard B qADC device sub-worker (``DBB_qadc_sub``).'/>



<!-- Slave Assembly Definition -->
  <slaves>
    <External name='tx' count='4'/>
    <External name='rx' count='4'/>


    <if test='dba_en'>
      <instance worker='ocpi.osp.n3xx.devices.jesd_raw2axi_interface.hdl' name='DBA_jesd_axi_mapper'/>
      <instance worker='ocpi.osp.n3xx.devices.n310_gpio.hdl' name='DBA_gpio'/>

      <if test='dba_tx0_en'>
        <instance worker='ocpi.osp.n3xx.devices.data_sink_qdac_ad9371_sub.hdl' name='DBA_qdac_sub'/>
        <connection>
          <external name='tx' index='0'/>
          <port if='dba_cic_int_en' name='input' instance='DBA_cic_int0'/> 
          <port if='!dba_cic_int_en' name='in' instance='DBA_qDAC0'/>
        </connection>
        <instance if='dba_cic_int_en' worker='ocpi.osp.n3xx.devices.cic_int_csts.hdl' name='DBA_cic_int0' connect='DBA_qDAC0'/>
        <instance worker='ocpi.osp.n3xx.devices.n310_qdac_csts.hdl' name='DBA_qDAC0'/>
      </if>

      <if test='dba_tx1_en'>
        <if test='!dba_tx0_en'>
          <instance worker='ocpi.osp.n3xx.devices.data_sink_qdac_ad9371_sub.hdl' name='DBA_qdac_sub'/>
        </if>
        <connection>
          <external name='tx' index='1'/>
          <port if='dba_cic_int_en' name='input' instance='DBA_cic_int1'/> 
          <port if='!dba_cic_int_en' name='in' instance='DBA_qDAC1'/>
        </connection>
        <instance if='dba_cic_int_en' worker='ocpi.osp.n3xx.devices.cic_int_csts.hdl' name='DBA_cic_int1' connect='DBA_qDAC1'/>
        <instance worker='ocpi.osp.n3xx.devices.n310_qdac_csts.hdl' name='DBA_qDAC1'/>
      </if>

      <if test='dba_rx0_en'>
        <instance worker='ocpi.osp.n3xx.devices.data_src_qadc_ad9371_sub.hdl' name='DBA_qadc_sub'/>
        <instance if='dba_cic_dec_en' worker='ocpi.osp.n3xx.devices.n310_qadc_csts.hdl' name='DBA_qADC0' connect='DBA_cic_dec0'/>
        <instance if='dba_cic_dec_en' worker='ocpi.osp.n3xx.devices.cic_dec_csts.hdl' name='DBA_cic_dec0'/>
        <instance if='!dba_cic_dec_en' worker='ocpi.osp.n3xx.devices.n310_qadc_csts.hdl' name='DBA_qADC0'/>
        <connection>
          <port if='dba_cic_dec_en' name='output' instance='DBA_cic_dec0'/>
          <port if='!dba_cic_dec_en' name='out' instance='DBA_qADC0'/>
          <external name='rx' index='0'/>
        </connection>
      </if>
 
      <if test='dba_rx1_en'>
        <if test='!dba_rx0_en'>
          <instance worker='ocpi.osp.n3xx.devices.data_src_qadc_ad9371_sub.hdl' name='DBA_qadc_sub'/>
        </if>
        <instance if='dba_cic_dec_en' worker='ocpi.osp.n3xx.devices.n310_qadc_csts.hdl' name='DBA_qADC1' connect='DBA_cic_dec1'/>
        <instance if='dba_cic_dec_en' worker='ocpi.osp.n3xx.devices.cic_dec_csts.hdl' name='DBA_cic_dec1'/>
        <instance if='!dba_cic_dec_en' worker='ocpi.osp.n3xx.devices.n310_qadc_csts.hdl' name='DBA_qADC1'/>
        <connection>
          <port if='dba_cic_dec_en' name='output' instance='DBA_cic_dec1'/>
          <port if='!dba_cic_dec_en' name='out' instance='DBA_qADC1'/>
          <external name='rx' index='1'/>
        </connection>
      </if>
    </if>


    <if test='dbb_en'>
      <instance worker='ocpi.osp.n3xx.devices.jesd_raw2axi_interface.hdl' name='DBB_jesd_axi_mapper'/>
      <instance worker='ocpi.osp.n3xx.devices.n310_gpio.hdl' name='DBB_gpio'/>

      <if test='dbb_tx0_en'>
        <instance worker='ocpi.osp.n3xx.devices.data_sink_qdac_ad9371_sub.hdl' name='DBB_qdac_sub'/>
        <connection>
          <external name='tx' index='2'/>
          <port if='dbb_cic_int_en' name='input' instance='DBB_cic_int0'/> 
          <port if='!dbb_cic_int_en' name='in' instance='DBB_qDAC0'/> 
        </connection>
        <instance if='dbb_cic_int_en' worker='ocpi.osp.n3xx.devices.cic_int_csts.hdl' name='DBB_cic_int0' connect='DBB_qDAC0'/>
        <instance worker='ocpi.osp.n3xx.devices.n310_qdac_csts.hdl' name='DBB_qDAC0'/>
      </if>

      <if test='dbb_tx1_en'>
        <if test='!dbb_tx0_en'>
          <instance worker='ocpi.osp.n3xx.devices.data_sink_qdac_ad9371_sub.hdl' name='DBB_qdac_sub'/>
        </if>
        <connection>
          <external name='tx' index='3'/>
          <port if='dbb_cic_int_en' name='input' instance='DBB_cic_int1'/> 
          <port if='!dbb_cic_int_en' name='in' instance='DBB_qDAC1'/>
        </connection>
        <instance if='dbb_cic_int_en' worker='ocpi.osp.n3xx.devices.cic_int_csts.hdl' name='DBB_cic_int1' connect='DBB_qDAC1'/>
        <instance worker='ocpi.osp.n3xx.devices.n310_qdac_csts.hdl' name='DBB_qDAC1'/>
      </if>

      <if test='dbb_rx0_en'>
        <instance worker='ocpi.osp.n3xx.devices.data_src_qadc_ad9371_sub.hdl' name='DBB_qadc_sub'/>
        <instance if='dbb_cic_dec_en' worker='ocpi.osp.n3xx.devices.n310_qadc_csts.hdl' name='DBB_qADC0' connect='DBB_cic_dec0'/>
        <instance if='dbb_cic_dec_en' worker='ocpi.osp.n3xx.devices.cic_dec_csts.hdl' name='DBB_cic_dec0'/>
        <instance if='!dbb_cic_dec_en' worker='ocpi.osp.n3xx.devices.n310_qadc_csts.hdl' name='DBB_qADC0'/>
        <connection>
          <port if='dbb_cic_dec_en' name='output' instance='DBB_cic_dec0'/>
          <port if='!dbb_cic_dec_en' name='out' instance='DBB_qADC0'/>
          <external name='rx' index='2'/>
        </connection>
      </if>
 
      <if test='dbb_rx1_en'>
        <if test='!dbb_rx0_en'>
          <instance worker='ocpi.osp.n3xx.devices.data_src_qadc_ad9371_sub.hdl' name='DBB_qadc_sub'/>
        </if>
        <instance if='dbb_cic_dec_en' worker='ocpi.osp.n3xx.devices.n310_qadc_csts.hdl' name='DBB_qADC1' connect='DBB_cic_dec1'/>
        <instance if='dbb_cic_dec_en' worker='ocpi.osp.n3xx.devices.cic_dec_csts.hdl' name='DBB_cic_dec1'/>
        <instance if='!dbb_cic_dec_en' worker='ocpi.osp.n3xx.devices.n310_qadc_csts.hdl' name='DBB_qADC1'/>
        <connection>
          <port if='dbb_cic_dec_en' name='output' instance='DBB_cic_dec1'/>
          <port if='!dbb_cic_dec_en' name='out' instance='DBB_qADC1'/>
          <external name='rx' index='3'/>
        </connection>
      </if>
    </if>
  

    <instance worker='ocpi.osp.n3xx.devices.n310_cpld_spi.hdl' name='n310_cpld_spi'/>
    <instance worker='ocpi.osp.n3xx.devices.n310_dsa.hdl' name='n310_dsa'/>
    <instance worker='ocpi.osp.n3xx.devices.ad9371_spi.hdl' name='n310_ad9371_spi'/>
    <instance worker='ocpi.osp.n3xx.devices.ad9371_gpio.hdl' name='n310_ad9371_gpio'/>
  </slaves>


  <!-- Device Configuration Properties-->
  <Property name='drcConfigStruct' type='struct' writable='true' description='**(Property will be deprecated in future releases)** Channel Configuration Structure used by API Controllers.'>
    <Member name='rx' type='bool'/>
    <Member name="tuning_freq_MHz" type="double" />
    <Member name="bandwidth_3dB_MHz" type="double" />
    <Member name="sampling_rate_Msps" type="double" />
    <member name='samples_are_complex' type='bool'/>
    <Member name="gain_dB" type="double" />
    <Member name='gain_mode' type='bool'/>
    <Member name="tolerance_tuning_freq_MHz" type="double" />
    <Member name="tolerance_bandwidth_3dB_MHz" type="double" />
    <Member name="tolerance_sampling_rate_Msps" type="double" />
    <Member name="tolerance_gain_dB" type="double" />
    <Member name="rf_port_num" type="enum" enums="PORT0,PORT1,PORT2,PORT3"/>
  </Property>

  <property name='spiControlStruct' type='struct' writable='true' description='**(Property will be deprecated in future releases)** Data Structure for SPI communication to hardware chips.'>
    <Member name='dbselect' type='bool'/>
    <Member name='address' type='ULong'/>
    <Member name='value' type='ULong'/>
    <Member name='r_w' type='bool'/>
  </property>

  <property name='spiReadback' type='ULong' volatile='true' description='**(Property will be deprecated in future releases)** Readback Register for SPI communication from hardware chips.'/>

  <Property name="dbSelectStruct" type="struct" writable="true" description='**(Property will be deprecated in future releases)** Daughterboard Select Structure for SPI communication.'>
    <Member name="cpld" type="enum" enums="DBA,DBB"/>
    <Member name="gpio" type="enum" enums="DBA,DBB"/>
    <Member name="dsa" type="enum" enums="DBA,DBB"/>
    <Member name="lmk" type="enum" enums="DBA,DBB"/>
    <Member name="txrx" type="enum" enums="DBA,DBB"/>
    <Member name="adf" type="enum" enums="DBA,DBB"/>
  </Property>

  <Property name="cpldStruct" type="struct" arrayLength="2" writable="true" description='**(Property will be deprecated in future releases)** Configuration Structure used by CPLD API Controller.'>
    <Member name="chan_sel" type="enum" enums="CHAN1,CHAN2,BOTH"/>
    <Member name="atr_state" type="enum" enums="IDLE,ON,ANY"/>
    <Member name="deferCommit" type="bool"/>
    <Member name="tx_sw1" type="enum" enums="TX_SW1_SHUTDOWNTXSW1,TX_SW1_FROMTXFILTERLP1700MHZ,TX_SW1_FROMTXFILTERLP3400MHZ,TX_SW1_FROMTXFILTERLP0800MHZ"/>
    <Member name="tx_sw2" type="enum" enums="enumPad0,TX_SW2_TOTXFILTERLP3400MHZ,TX_SW2_TOTXFILTERLP1700MHZ,enumPad3,TX_SW2_TOTXFILTERLP0800MHZ,enumPad5,enumPad6,enumPad7,TX_SW2_TOTXFILTERLP6400MHZ"/>
    <Member name="tx_sw3" type="enum" enums="TX_SW3_TOTXFILTERBANKS,TX_SW3_BYPASSPATHTOTRXSW"/>
    <Member name="sw_trx" type="enum" enums="SW_TRX_FROMLOWERFILTERBANKTXSW1,SW_TRX_FROMTXUPPERFILTERBANKLP6400MHZ,SW_TRX_RXCHANNELPATH,SW_TRX_BYPASSPATHTOTXSW3"/>
    <Member name="rx_sw1" type="enum" enums="RX_SW1_TXRXINPUT,RX_SW1_RXLOCALINPUT,RX_SW1_TRXSWITCHOUTPUT,RX_SW1_RX2INPUT"/>
    <Member name="rx_sw2" type="enum" enums="RX_SW2_SHUTDOWNSW2,RX_SW2_LOWERFILTERBANKTOSWITCH3,RX_SW2_BYPASSPATHTOSWITCH6,RX_SW2_UPPERFILTERBANKTOSWITCH4"/>
    <Member name="rx_sw3" type="enum" enums="RX_SW3_FILTER2100X2850MHZ,RX_SW3_FILTER0490LPMHZ,RX_SW3_FILTER1600X2250MHZ,enumPad3,RX_SW3_FILTER0440X0530MHZ,RX_SW3_FILTER0650X1000MHZ,RX_SW3_FILTER1100X1575MHZ,RX_SW3_SHUTDOWNSW3"/>
    <Member name="rx_sw4" type="enum" enums="enumPad0,RX_SW4_FILTER2100X2850MHZFROM,RX_SW4_FILTER1600X2250MHZFROM,enumPad3,RX_SW4_FILTER2700HPMHZ"/>
    <Member name="rx_sw5" type="enum" enums="enumPad0,RX_SW5_FILTER0440X0530MHZFROM,RX_SW5_FILTER1100X1575MHZFROM,enumPad3,RX_SW5_FILTER0490LPMHZFROM,enumPad5,enumPad6,enumPad7,RX_SW5_FILTER0650X1000MHZFROM"/>
    <Member name="rx_sw6" type="enum" enums="enumPad0,RX_SW6_LOWERFILTERBANKFROMSWITCH5,RX_SW6_UPPERFILTERBANKFROMSWITCH4,enumPad3,RX_SW6_BYPASSPATHFROMSWITCH2"/>
    <Member name="lowband_mixer_path_sel" type="enum" enums="LOWBAND_MIXER_PATH_SEL_BYPASS,LOWBAND_MIXER_PATH_SEL_LOBAND"/> 
    <Member name="enb_lowband_mixer" type="bool"/>
    <Member name="tx_led" type="bool" />
    <Member name="tx_pa_enb" type="bool" />
    <Member name="tx_amp_enb" type="bool" />
    <Member name="tx_myk_enb" type="bool" />
    <Member name="rx_led" type="bool" />
    <Member name="rx2_led" type="bool" />
    <Member name="rx_amp_enb" type="bool" />
    <Member name="rx_myk_enb" type="bool" />
    <Member name="rx_lna1_enb" type="bool" />
    <Member name="rx_lna2_enb" type="bool" />
    <Member name="regAddr" type="short"/>
    <Member name="regData" type="short"/>
  </Property>

  <Property name='cpldGpioStruct' type='struct' arraylength="2" writable='true' description='**(Property will be deprecated in future releases)** Configuration Structure used by CPLD GPIO API Controller.'>
    <member name='cpld_gpio_tx1' type='bool'/>
    <member name='cpld_gpio_tx2' type='bool'/>
    <member name='cpld_gpio_rx1' type='bool'/>
    <member name='cpld_gpio_rx2' type='bool'/>
  </Property>

  <Property name="dsaStruct" type="struct" arrayLength="2" writable="true" description='**(Property will be deprecated in future releases)** Configuration Structure used by the N310 Digital Step Attenuators (DSA) API Controller.'> 
    <Member name="dsa_tx1_atten" type="double" />
    <Member name="dsa_tx2_atten" type="double" />
    <Member name="dsa_rx1_atten" type="double" />
    <Member name="dsa_rx2_atten" type="double" />
  </Property> 

  <Property name="lmkStruct" type="struct" arraylength='2' writable="true" description='**(Property will be deprecated in future releases)** Configuration Structure used by the Clock Source (LMK) API Controller.'>
    <Member name="masterClockRate" type="long"/>
    <Member name="referenceClockRate" type="long"/>
    <Member name="requestSysrefPattern" type="double" />
    <Member name="regAddr" type="short"/>
    <Member name="regData" type="short"/>
  </Property>

  <Property name="transceiverStruct" type="struct" arraylength='2' writable="true" 
    description='**(Property will be deprecated in future releases)** Configuration Structure used by the AD9371 Transceiver API Controller.'>
    <Member name="clkgen_parentRate" type="ULong" />
    <Member name="clkgen_setRate" type="ULong" />
  </Property>

  <Property name="adfStruct" type="struct" arraylength='2' writable="true" description='**(Property will be deprecated in future releases)** Configuration Structure used by the RF LO Synthesizers  API Controller.'>
      <Member name="lo_freq" type="longlong"/>
      <Member name="ref_clock_freq" type="longlong"/>
      <Member name="int_n_mode" type="bool"/>
  </Property>

  <Property name='channelConfig' type='bool' writable='true' writesync='1' description='ISR switch to handle drcConfigStruct datatype and algorithm/controller flow of a full channel configuration'/>

  <Property name='debugConfig' type='bool' writable='true' writesync='1' description='Debug the inner workings of the m_properties.configurations'/>



  <!-- Device API Declarations -->
  <Property name="cpldControllerOrdinal" type="enum" writable="true" writesync='1' description="**(Property will be deprecated in future releases)** CPLD API Controller Calls" enums="cpldControllerOrdinalzeropad,cpldControllerOrdinalonepad,set_tx_switches,set_rx_switches,set_tx_atr_bits,set_trx_sw_atr_bits,set_rx_input_atr_bits,set_rx_atr_bits,set_rx_lna_atr_bits, set_scratch, get_scratch, reset, PS_SignatureReg, PS_MinorRevReg, PS_MajorRevReg, PS_BuildCodeLSB, PS_BuildCodeMSB, PS_Scratch, PS_CpldControl, PS_LmkControl, PS_LoStatus, PS_MykonosControl, getCPLDReg, setCpldReg, mykonosReset, spiReadWrite" />

  <Property name='cpldGpioControllerOrdinal' type='enum' writable='true' writesync='1' description="**(Property will be deprecated in future releases)** CPLD GPIO API Controller Calls" enums='cpld_gpio_tx1, cpld_gpio_tx2, cpld_gpio_rx1, cpld_gpio_rx2, cpld_gpio_reset'/>

  <Property name="dsaControllerOrdinal" type="enum" writable="true" writesync='1' description="**(Property will be deprecated in future releases)** Digital Step Attenuators (DSA) API Controller Calls" enums="dsa_tx1, dsa_tx2, dsa_rx1, dsa_rx2, dsa_reset"/>

  <Property name="lmk04828ControllerOrdinal" type="enum" writable="true" writesync='1' description="**(Property will be deprecated in future releases)** Clock Source (LMK) API Controller Calls" enums="getProductID, lmk04828ControllerOrdinalonepad, mcrConfigure, fullConfigure, requestSysref, getLmkReg, setLmkReg, lmk04828_example_application_testing, spiReadWrite, lmk04828ControllerOrdinalninepad"/>

  <Property name="adfControllerOrdinal" type="enum" writable="true" writesync='1' description="**(Property will be deprecated in future releases)** RF LO Synthesizer API Controller Calls" enums="adfControllerOrdinalzeropad, adfControllerOrdinalonepad, _lo_enable, _lo_disable" />

  <Property name="transceiverControllerOrdinal" type="enum" writable="true" writesync='1' description="**(Property will be deprecated in future releases)** AD9371 Transceiver API Controller Calls" enums="class_MYKONOS_getProductId,configure_transceiver,axi_clkgen_set_rate,axi_clkgen_get_rate,axi_clkgen_init, headless, run_configuration, gpioTest, adrv9371_gpio_test, transceiverControllerOrdinalninepad" />

  <Property name="intControllerOrdinal" type="enum" writable="true" writesync='1' description="**(Property will be deprecated in future releases)** CIC Intepolation API Controller Calls" enums="interp_upsamplefactor, interp_scaleoutput, interp_flushlength"/>

  <Property name="decControllerOrdinal" type="enum" writable="true" writesync='1' description="**(Property will be deprecated in future releases)** CIC Decimation API Controller Calls" enums="decim_downsamplefactor, decim_scaleoutput, decim_flushlength"/>

</RccWorker>